package application;

import java.io.Serializable;
import java.net.URI;

import winterwell.jtwitter.Twitter;

public class Profile implements Serializable {
	private static final long serialVersionUID = 201007242142L;
	
	private String userId; //the Id that specify the user by the server
	private String username;
	private String location;
	private String web;
	private String bio;	
	
	public Profile(String userId, String username, String location, String web, String bio) {
		this.userId = userId;
		this.username = username;
		this.location = location;
		this.web = web;
		this.bio = bio;
	}
	
	public Profile(long userId, String username, String location, URI web, String bio) {
		this.userId = String.valueOf(userId);
		this.username = username;
		this.location = location;
		if(web != null) {
			this.web = web.toString();
		} else {
			this.web = "";
		}
		this.bio = bio;
	}
	
	public Profile(Twitter.User tuser) {
		userId = new Long(tuser.id).toString();
		username = tuser.screenName;
		location = tuser.location;
		if(tuser.website != null) {
			web = tuser.website.toString();
		} else {
			web = "";
		}
		bio = tuser.description;
	}
	
	//Getters.	
	public String getUserId() {
		return userId;
	}
	
	public String getUserName() {
		return username;
	}
	
	public String getWeb() {
		return web;
	}
	
	public String getLocation() {
		return location;
	}
	
	public String getBio() {
		return bio;
	}
	
	public String toString() {
		return userId + " " + username + " " + location + " " + "\n";
	}
	
	public void print() {
		//System.out.println("userId -> " + userId);
		//System.out.println("nodeId -> " + nodeId);
		//System.out.println("username -> " + username);
		//System.out.println("location -> " + location);
		//System.out.println("web -> " + web);
		//System.out.println("bio -> " + bio);
		System.out.println("----" + userId + " " + username + " " + location + " " + web + " " + bio);
	}
}
