package application;

import java.io.Serializable;
import java.util.Date;

import winterwell.jtwitter.Twitter;

public class Status implements Serializable {
	private static final long serialVersionUID = 201007242141L;
	
	private String statusId;
	private String text;
	private String author;
	private String authorId;
	private long time;
	
	private boolean gossip;
	
	public Status(String statusId, String text, String author, String authorId, long time) {
		this.statusId = statusId;
		this.text = text;
		this.author = author;
		this.authorId = authorId;
		this.time = time;
	}
	
	public Status(String statusId, String text, String author, String authorId, long time, boolean g) {
		this.statusId = statusId;
		this.text = text;
		this.author = author;
		this.authorId = authorId;
		this.time = time;
		this.gossip = g;
	}
	
	public Status(Twitter.Status ts) {
		this.statusId = String.valueOf(ts.getId());
		this.text     = ts.getText();
		this.author   = ts.getUser().getScreenName();
		this.authorId = String.valueOf(ts.getUser().getId());
		this.time     = ts.getCreatedAt().getTime();
	}
	
	public Status(Twitter.Status ts, boolean g) {
		this.statusId = String.valueOf(ts.getId());
		this.text     = ts.getText();
		this.author   = ts.getUser().getScreenName();
		this.authorId = String.valueOf(ts.getUser().getId());
		this.time     = ts.getCreatedAt().getTime();
		this.gossip = g;
	}
	
	public String toString() {
		//return statusId+" "+author+" "+text+" "+time+"\n";
		String dt = new Date(time).toString();
		return author + " ----> " + text + " @" + dt + "\n";
	}
	
	//Geters
	public String getStatusId() {
		return statusId;
	}
	
	public String getText() {
		return text;
	}
	
	public String getAuthor() {
		return author;
	}
	
	public String getAuthorId() {
		return authorId;
	}
	
	public long getTime() {
		return time;
	}
	
	public boolean getGossipOrNot() {
		return gossip;
	}
	
	public void setGossipOrNot(boolean g) {
		this.gossip = g;
	}
}
