package guinterface;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.GridLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.jfree.ui.RefineryUtilities;

import toolbox.RunBrowser;

import application.Cuckoo;
import application.Profile;

public class HeadFrame extends JFrame {
	private static final long serialVersionUID = 201008121358L;
	
	private Cuckoo cuckoo;
	private ImageIcon icon = new ImageIcon("image/cuckoo.jpg");
	
	public HeadFrame(Cuckoo c) {
		cuckoo = c;
		setLayout(new BorderLayout (10, 20));
		
		JPanel dumpPanel = new JPanel();
		//dumpPanel.setLayout(new BorderLayout (10, 20));
		Profile p = cuckoo.getProfile();
		dumpPanel.add(new PicPanel(p.getUserId()), BorderLayout.WEST);
		dumpPanel.add(new InfoPanel(p.getUserId(), p.getUserName(), p.getLocation(), p.getBio(), p.getWeb()), BorderLayout.CENTER);
		
		add(dumpPanel, BorderLayout.CENTER);
		
		pack();
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		RefineryUtilities.centerFrameOnScreen(this);
		setIconImage(icon.getImage());
	}
	
	private class PicPanel extends JPanel {
		private static final long serialVersionUID = 201008121401L;
		
		private JLabel headLable;
		private ImageIcon headIcon; 
		
		public PicPanel(String uid) {
			headIcon = new ImageIcon("image/"+uid+".jpg");
			headLable = new JLabel(headIcon);
			
			setLayout(new BorderLayout (5, 10));
			add(headLable, BorderLayout.NORTH);
		}
	}
	
	private class InfoPanel extends JPanel {
		private static final long serialVersionUID = 201008121402L;
		
		private JLabel idLabel;
		private JLabel nameLabel;
		private JLabel locationLabel;
		private JLabel bioLabel;
		private JLabel websiteLabel;
		
		public InfoPanel(String id, String username, String location, String bio, String web) {
			idLabel       = new JLabel("UserId:   " + id);
			nameLabel     = new JLabel("Username: " + username);
			locationLabel = new JLabel("Location: " + location);
			bioLabel      = new JLabel("Bio:      " + bio);
			websiteLabel  = new JLabel("<html><body>Website:     <font color=#0000ff><u>"+web+"</u></body></html>");
			
			websiteLabel.setCursor(new Cursor(Cursor.HAND_CURSOR));
			websiteLabel.addMouseListener(new OpenWebSiteActionListener(web));
			
			setLayout(new GridLayout(5, 1));
			
			add(idLabel);
			add(nameLabel);
			add(locationLabel);
			add(bioLabel);
			add(websiteLabel);

		}
	}
	
	private class OpenWebSiteActionListener extends MouseAdapter {
		private String web;
		
		public OpenWebSiteActionListener(String w) {
			web = w;
		}
		
		public void mouseClicked(MouseEvent e) {
			try {
				new RunBrowser(web).runBroswer();
			} catch(Exception ex) {  
	        	ex.printStackTrace();  
	        }  
	    }
	}
	
	/*
	public static void main(String[] args) {
		HeadFrame hf = new HeadFrame(null);
	}*/
}
