package guinterface;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.jfree.ui.RefineryUtilities;

import toolbox.RunBrowser;

public class HelpFrame extends JFrame {
	private static final long serialVersionUID = 201008121523L;
	private ImageIcon icon = new ImageIcon("image/cuckoo.jpg");
	
	public HelpFrame() {
		setLayout(new BorderLayout (10, 20));
		
		JPanel dumpPanel = new JPanel();
		//dumpPanel.setLayout(new BorderLayout (10, 20));
		dumpPanel.add(new CuckooPicPanel(), BorderLayout.WEST);
		dumpPanel.add(new WhoWeArePanel(), BorderLayout.CENTER);
		add(dumpPanel, BorderLayout.CENTER);
		
		pack();
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		RefineryUtilities.centerFrameOnScreen(this);
		setIconImage(icon.getImage());
	}
	
	private class CuckooPicPanel extends JPanel {
		private static final long serialVersionUID = 201008121510L;
		
		private ImageIcon headIcon = new ImageIcon("image/cuckoo.jpg");
		private JLabel headLable = new JLabel(headIcon);
		
		public CuckooPicPanel() {
			setLayout(new BorderLayout (5, 10));
			add(headLable, BorderLayout.NORTH);
		}
	}
	
	private class WhoWeArePanel extends JPanel {
		private static final long serialVersionUID = 201008121511L;
		
		private JLabel whoareweLabel;
		private JLabel websiteLabel;
		private String web = "http://mycuckoo.org/";
		
		public WhoWeArePanel() {
			whoareweLabel = new JLabel(
					"<html><body>" +
					"Hi, we are researchers from University of Goettingen, Germany<br>" +
					"and Deutsche Telekom Laboratories.<br><br>" +
					"Twittering by Cuckoo -- <br>" +
					"Decentralized and Socio-Aware Online Microblogging Services.<br><br>" +
					"<font color=#FF0000>Tianyin Xu, <font color=#FF9900>Yang Chen, <font color=#00cc00>Xiaoming Fu, <font color=#6600ff>Pan Hui<br><br>" +
					"</body></html>");
			websiteLabel  = new JLabel("<html><body><font color=#0000ff><u>"+web+"</u></body></html>");
			websiteLabel.setCursor(new Cursor(Cursor.HAND_CURSOR));
			websiteLabel.addMouseListener(new OpenWebSiteActionListener(web));
				
			setLayout(new BorderLayout(5, 1));
			add(whoareweLabel, BorderLayout.CENTER);
			add(websiteLabel, BorderLayout.SOUTH);

		}
	}
	
	private class OpenWebSiteActionListener extends MouseAdapter {
		private String web;
		
		public OpenWebSiteActionListener(String w) {
			web = w;
		}
		
		public void mouseClicked(MouseEvent e) {
			try {
				new RunBrowser(web).runBroswer();
			} catch(Exception ex) {  
	        	ex.printStackTrace();  
	        }  
	    }
	}

}
