package infrastructure;

import rice.pastry.Id;
import rice.pastry.NodeIdFactory;

/**
 * Constructs NodeIds for virtual nodes derived from the user Id (deterministic id)
 * 
 * @version $Id: IPNodeIdFactory.java 3613 2010-04-03 18:20:14Z jstewart $
 * 
 * @author Tianyin Xu
 */
public class DeterministicNodeIdFactory implements NodeIdFactory {

	private String userId;
	
	public DeterministicNodeIdFactory (String userId) {
		this.userId = userId;
	}
	
	public Id generateNodeId() {

		Id NodeId = Id.build(new Long(userId).toString());
		return NodeId;
	}
	
	//Just For Test
	public static void main(String[] args) {
		//for(int i=0; i<10; i++) {
		Id did1 = new DeterministicNodeIdFactory("0000000001").generateNodeId();
		Id did2 = new DeterministicNodeIdFactory("0000000002").generateNodeId();
		Id did3 = new DeterministicNodeIdFactory("0000000003").generateNodeId();
		//System.out.println(did2.compareTo(did1));
		
		String str1 = did2.toString();
		String str2 = did1.toString();
		System.out.println(str1.compareTo(str2));
		
		System.out.println(did1.toString());
		System.out.println(did2.toString());
		System.out.println(did3.toString());
		//}
	}

}
