package message;
import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.*;
import rice.p2p.util.BloomFilter;

public class ReqStatusMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201004010358L;
	public static final short TYPE = 11;
	
    private long time;
    
    // Constructor
    public ReqStatusMsg(Id from, Id to, String fid, String tid, NodeHandle nh, BloomFilter bf, long time) {
    	super(from, to, fid, tid, nh, bf);
    	this.time = time;
    }

	//@Override: required by the "RawMessage" Interface
	public short getType() {
		return TYPE;
	}

	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
	    buf.writeLong(time);
	}
	
	public long getTime() {
		return time;
	}

	public ReqStatusMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    time = buf.readLong();
	}
}
