package message;

import java.io.IOException;

import application.Profile;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;

public class RplFollowMsg extends CuckooMsg {
	private static final long serialVersionUID = 201004201510L;
	public static final short TYPE = 5;
	
	private String userId;     // the Id that specify the user in the server
	private String username;
	private String location;
	private String web;
	private String bio;
	
	private String partnerIds;
	
	public RplFollowMsg(Id from, Id to, String fid, String tid, NodeHandle nh, String userId, String nodeId, String username, String location, String web, String bio, String pids) {
		super(from, to, fid, tid, nh);
		
		this.userId = userId;
		this.username = username;
		this.location = location;
		this.web = web;
		this.bio = bio;
		
		this.partnerIds = pids;
	}
	
	public RplFollowMsg(Id from, Id to, String fid, String tid, NodeHandle nh, Profile profile, String pids) {
		super(from, to, fid, tid, nh);
		
		this.userId = profile.getUserId();
		this.username = profile.getUserName();
		this.location = profile.getLocation();
		this.web = profile.getWeb();
		this.bio = profile.getBio();
		
		this.partnerIds = pids;
	}
	
	public void printProfileMsg() {
		//System.out.println("userId: " + userId);
		//System.out.println("nodeId: " + nodeId);
		//System.out.println("username: " + username);
		//System.out.println("location: " + location);
		//System.out.println("web: " + web);
		//System.out.println("bio: " + bio);
		System.out.println(userId + " " + username + " " + location + " " + web + " " + bio);
	}
	
	public Profile getProfile() {
		return new Profile(this.userId, this.username, this.location, this.web, this.bio);
	}
	
	public short getType() {
		return TYPE;
	}

	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
		
		buf.writeUTF(userId);
	    buf.writeUTF(username);
	    buf.writeUTF(location);
	    buf.writeUTF(web);
	    buf.writeUTF(bio);
	    
	    buf.writeUTF(partnerIds);
	}

	public RplFollowMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    
	    userId = buf.readUTF();
		username = buf.readUTF();
	    location = buf.readUTF();
		web = buf.readUTF();
		bio = buf.readUTF();
		
		partnerIds = buf.readUTF();
	}
	
	public String getPartnerIds() {
		return  partnerIds;
	}
}
